package MKDoc::Apache::Auth::Any;
use Apache::Constants qw (:common);
use 5.6.1;
use strict;
use warnings;

our $VERSION = "0.1";


sub handler
{
    my $r = shift;
    my ($res, $sent_pw) = $r->get_basic_auth_pw;
    return $res if $res != OK;
    
    my $user = $r->connection->user;
    unless ($user and $sent_pw)
    {
        $r->note_basic_auth_failure;
        $r->log_reason ("Both username and passwords must be provided, ", $r->filename);
        return AUTH_REQUIRED;
    }
    
    return OK;
}


1;
__END__
