# basic template tokenization test
# but with a unicode string
use lib ('..');
use MKDoc;
use lib::Config;
use lib::Template;
use Data::Dumper;
use strict;

eval {
    # initialize template module
    $lib::Template::CONFIG = new lib::Config;
    $lib::Template::CONFIG->set (qw /LEFT_TOKEN <%/);
    $lib::Template::CONFIG->set (qw /RIGHT_TOKEN %>/);

    # $lib::Template::CONFIG->set ('BASE_DIR', $CONFIG->{SITE_DIR});
    $lib::Template::CONFIG->set ('var', 'lib::Template::Var');
    $lib::Template::CONFIG->set ('if', 'lib::Template::If');
    $lib::Template::RIGHT_TOKEN = quotemeta ('%>');
    $lib::Template::LEFT_TOKEN  = quotemeta ('<%');

    # $lib::Template::BASE_DIR    = $CONFIG->{SITE_DIR};
    $lib::Template::TOKEN_REGEX = $lib::Template::LEFT_TOKEN . '.*?' . $lib::Template::RIGHT_TOKEN;
    $lib::Template::STASH = {};

    my $tmpl_data = 'this is a unicode ' . "\x{E9}" . '<% ' . "\x{FEFF}" . 'var name="FOO" %> test';
    my $tmpl_hash = { FOO => 'foo' };
    my $tmpl = new lib::Template ( data => $tmpl_data, hash => $tmpl_hash );

    my $array = $tmpl->_tokenize;
    die '[ Unicode template tokenization]' unless (@{$array} == 3);
};

if (defined $@ and ref $@) { $@ = "\n" . Dumper ($@) . "\n" }
die "FAILED: $@" if (defined $@ and $@);
