# template include test with unicode strings
# (was a bug)
use lib ('..');
use lib::Config;
use MKDoc;
use lib::Template;
use Data::Dumper;
use File::Temp qw /tempfile/;
use utf8;
use strict;

eval {
    # initialize template module
    $lib::Template::CONFIG = new lib::Config;
    $lib::Template::CONFIG->set (qw /LEFT_TOKEN <%/);
    $lib::Template::CONFIG->set (qw /RIGHT_TOKEN %>/);

    # $lib::Template::CONFIG->set ('BASE_DIR', $CONFIG->{SITE_DIR});
    $lib::Template::CONFIG->set ('include', 'lib::Template::Include');
    $lib::Template::CONFIG->set ('var', 'lib::Template::Var');
    $lib::Template::CONFIG->set ('if', 'lib::Template::If');
    $lib::Template::RIGHT_TOKEN = quotemeta ('%>');
    $lib::Template::LEFT_TOKEN  = quotemeta ('<%');
    
    # $lib::Template::BASE_DIR    = $CONFIG->{SITE_DIR};
    $lib::Template::TOKEN_REGEX = $lib::Template::LEFT_TOKEN . '.*?' . $lib::Template::RIGHT_TOKEN;
    $lib::Template::STASH = {};

    my ($fh, $temp_file) = tempfile;
    open FP, ">$temp_file";
    print FP "Some unicode stuff: \x{FEFF} \x{E9}";
    close FP;
    
    my $tmpl_data = "test: <% include file=\"$temp_file\" %> yo!\n";
    my $tmpl_hash = {};
    my $tmpl = new lib::Template ( data => $tmpl_data, hash => $tmpl_hash );
    die '[ Unicode template include ]' unless ($tmpl->parse =~ /Some unicode stuff/);
};

if (defined $@ and ref $@) { $@ = "\n" . Dumper ($@) . "\n" }
die $@ if (defined $@ and $@);

